#!/bin/bash
#
#DESKTOP="192.168.178.24"
DESKTOP="$1"
#BACKUPDIR="."
BACKUPDIR="$2"
USERDIR="/home/${USER}"
FULLBACKUPDIR="${USERDIR}/${BACKUPDIR}"

TITLE="Backup Desktop nach Notebook"
TEXT="Bitte whlen Sie die zu sichernden Verzeichnisse\n\
welche vom Desktop auf das Notebook gesichert werden sollen,\n\
aus der folgenden Liste aus.\n\n\
Sychronisieren von Computer mit IP: ${DESKTOP}\n\
in das lokale Verzeichnis: ${FULLBACKUPDIR}\n\n\
ALLE DATEIEN WERDEN OHNE NACHFRAGE BERSCHRIEBEN.\n\
Die Sicherung erfolgt in das Heimatverzeichnis dieses Benutzers."
HEIGHT="600"
WIDTH="600"

# Parameter Testen
[ "$BACKUPDIR" ] || zenity --error --width="900" --title="$TITLE" \
--text="Sie mssen als zweiten Parameter ein Verzeichnis angeben in das gesichert werden soll. Dies kann ein extra Backupverzeichnis sein, oder einfach '.' (Punkt) fr das aktuellen Heimatverzeichnsis.\n\n\
ACHTUNG, alle Daten werden dabei berschrieben.\n\n\
Legen sie dazu einen Anwendungsstarter im Panel\n\
mit folgendem Inhalt an: \n\n\
${0} 192.168.178.80 .\n\
${0} 192.168.178.80 mein_backup."

[ "$BACKUPDIR" ] || exit 1

# Ping Desktop
ERROR_PING="1"

ping -c1 $DESKTOP && ERROR_PING="0"
[ "$ERROR_PING" == "1" ] && zenity --error \
	--title="$TITLE" --text "Rechner mit der IP $DESKTOP ist nicht erreichbar.\n\
Bitte erst die Netzwerkverbindung herstellen.\n\
Programm wird beendet."
[ "$ERROR_PING" == "1" ] && exit 1

# Ins Backupverzeichnis wechseln
mkdir -p ${FULLBACKUPDIR}
cd ${FULLBACKUPDIR}

DOC="Dokumente"
PIC="Bilder"
MUS="Musik"
VID="Videos"
DES="Desktop"
WEB=".mozilla"
EMAIL=".mozilla-thunderbird"
VBOX=".VitualBox"

LIST="$(zenity  \
	--height="$HEIGHT" --width="$WIDTH" \
	--title="$TITLE" \
	--text="$TEXT" \
	--list --checklist --multiple \
	--separator="  " \
	--print-column='ALL' \
	--column="Backup" --column="Verzeichnis" \
	true "$DOC" \
	true "$PIC" \
	true "$MUS" \
	true "$VID" \
	true "$DES" \
	true "$WEB" \
	true "$EMAIL" \
	false "$VBOX")"

(
cd /home/$USER/$BACKUPDIR
sleep 5
ERROR_RSYNC=1
#XPARAM=" -bg white -fg black -T 'Backup, Abbrechen mit Strg+C' "
XTERMTITLE="Backup luft, Abbrechen mit Strg+C"
PERCENT=0

for entry in ${LIST}; do 
	PERCENT=$(($PERCENT+10))
	echo "${PERCENT}" 
        echo "# $entry wird gesichert." 
	rsync -av --delete ${DESKTOP}:${USERDIR}/${entry} ${USERDIR}/${BACKUPDIR}/.
done

echo "100" "Backup beendet."
) | zenity  --progress \
		--auto-close \
		--height="$HEIGHT" --width="$WIDTH" \
		--title="$TITLE" \
		--text="Backup luft ..." \
		--percentage=0

[ "$?" = -1 ] && zenity --error --text="Backup wurde abgebrochen."
